#!/usr/bin/env python2.2
import os
import sys
import popen2
import math
import string
import fileinput
import tempfile
  
def avestd(vals):
    (sum, sum2) = (0.,0.)
    N = float(len(vals))
    for val in vals:
        sum  = sum  + float(val)
        sum2 = sum2 + float(val)*float(val)
    if N == 0:
        ave = 0
        std = 0
    elif N == 1:
        ave = sum
        std = 0
    else:
        ave = sum /  N
        diff2 = sum2-(N*ave*ave)
        if diff2 >= 0.0:
            std = math.sqrt( diff2 / (N-1.0) )
        else:
            std = 0
    return(ave,std)

def minus90toplus90(x):
    if (x < -90.0):
        return x + 360
    else:
        return x

torsions = os.path.join( os.path.dirname(sys.argv[0]), '..','chainstat','torsions')
phi = []
psi = []
omega = []
n_ca = []
n_ca_c = []
ca_c = []
ca_c_n = []
c_n = []
c_n_ca = []
for line in fileinput.input():
    try:
        words = string.split(line)
        tmpfile = tempfile.mktemp()
        cmdln = '%s %s > %s' % (torsions, words[0], tmpfile)

        status = os.system( cmdln)
        
        if (status != 0):
            os.system('rm %s' % tmpfile)
            pass

        #print 'got here'
        
        ofile = open(tmpfile,'r')
        outlines = ofile.readlines()
        ofile.close()
        os.system('rm %s' % tmpfile)

        #print outlines[:5]
        
        allFields = map(string.split, outlines[2:]) #ignore hdr: lines 1-2
        
        thisPhi = map( (lambda x: float(x[2])), allFields)
        thisPsi = map( (lambda x: float(x[3])), allFields)
        thisOmega = map( (lambda x: float(x[4])), allFields)
        this_n_ca = map( (lambda x: float(x[5])), allFields)
        this_n_ca_c = map( (lambda x: float(x[6])), allFields)
        this_ca_c = map( (lambda x: float(x[7])), allFields)
        this_ca_c_n = map( (lambda x: float(x[8])), allFields)
        this_c_n = map( (lambda x: float(x[9])), allFields)
        this_c_n_ca = map( (lambda x: float(x[10])), allFields)
                
        phi = phi + [x for x in thisPhi if x < 360.0]
        psi = psi + [x for x in thisPsi if x < 360.0]
        omega = omega + [x for x in thisOmega if x < 360.0]
        n_ca = n_ca +  [x for x in this_n_ca  if x < 5.0]
        n_ca_c = n_ca_c +  [x for x in this_n_ca_c  if x < 999.0]
        ca_c = ca_c +  [x for x in this_ca_c  if x < 5.0]
        ca_c_n = ca_c_n +  [x for x in this_ca_c_n  if x < 999.0]
        c_n = c_n +  [x for x in this_c_n  if x < 5.0]
        c_n_ca = c_n_ca +  [x for x in this_c_n_ca  if x < 999.0]

    except:
        pass
 
phi1 = map( minus90toplus90, phi)
(phiAve, phiStd)  = avestd( phi1)
psi1 = map( minus90toplus90, psi)
(psiAve, psiStd)  = avestd( psi1)
omega1 = map( minus90toplus90, omega)
(omegaAve, omegaStd)  = avestd( omega1)


#print bond lengths
n = len(n_ca)

for i in range(n):
    print '%8.3f '%(n_ca.pop(0)),
    print '%8.3f '%(ca_c.pop(0)),
    if i!=n-1:
        print '%8.3f '%(c_n.pop(0)),
print

#print bond angles
for i in range(n):
    print '%8.3f '%(n_ca_c.pop(0)),
    if i!=n-1:
        print '%8.3f '%(ca_c_n.pop(0)),
        print '%8.3f '%(c_n_ca.pop(0)),
print


if (len(psi1) != len(phi1) or len(psi1) != len(omega1)):
    print 'Not equal number of phi-psi-omega angles'
    sys.exit(1)

for i in range(len(psi1)):
    print psi1[i],
    print " ",
    print omega1[i],
    print " ",
    print phi1[i],
    print " ",
print
        
